/*

This is a program I wrote to test the LineEdit Functions.  It adds and deletes
comments "randomly" from the database that is created by MAIN.PRG.  YOU MUST
compile and run MAIN.PRG before running blitz, as it expects to find those
databases when it runs.

The NUMBERS.DBF is a file that I just flooded with numbers to get a
"fairly random" set of numbers to work with.

*/

#include "klipper.ch"

FUNCTION _CommentBlitz()

LOCAL  cNotes1, cNotes2, cText, nRec, nBlock, lAdd, nFile, nReps, nKey, i, nInit, nAddWeight

FIELD SerNo, Comment

MEMVAR cB1
MEMVAR cB2
MEMVAR cB3
MEMVAR cB4
MEMVAR cB5
MEMVAR cB6
MEMVAR cB7
MEMVAR cB8
MEMVAR cB9

PRIVATE cB1
PRIVATE cB2
PRIVATE cB3
PRIVATE cB4
PRIVATE cB5
PRIVATE cB6
PRIVATE cB7
PRIVATE cB8
PRIVATE cB9

_FScreen('Comment Blitz')

USE TestData ALIAS TestData NEW EXCLUSIVE; ERASE TESTDATA.NTX ; INDEX ON SerNo TO TestData ; PACK
USE TestNote ALIAS TestNote NEW EXCLUSIVE; ERASE TESTNOTE.NTX ; INDEX ON SerNo+Substr(Comment,1,4) TO TestNote ; PACK
USE Numbers  ALIAS Numbers  NEW EXCLUSIVE; GOTO TOP

nInit = _GetNum('Init seed?','999')
GOTO (nInit)

nFile = fopen('pulltext.txt')

cB1  = _PullText(nFile,'@B1','#B1')
cB2  = _PullText(nFile,'@B2','#B2')
cB3  = _PullText(nFile,'@B3','#B3')
cB4  = _PullText(nFile,'@B4','#B4')
cB5  = _PullText(nFile,'@B5','#B5')
cB6  = _PullText(nFile,'@B6','#B6')
cB7  = _PullText(nFile,'@B7','#B7')
cB8  = _PullText(nFile,'@B8','#B8')
cB9  = _PullText(nFile,'@B9','#B9')

fclose(nFile)

if _Q_Confirm('ZAP COMMENTS FILE?')

    SELECT TestNote
    ZAP

    SELECT TestData
    REPLACE ALL MemoField        WITH ""
    REPLACE ALL TestData->Access WITH 0
    REPLACE ALL TestData->Add    WITH 0
    REPLACE ALL TestData->Delete WITH 0

endif

_KeyList('positive = more adds / less deletes, Negative reverses, 0 appx equal')

nAddWeight = 99

while ( nAddWeight < -5 .and. nAddWeight > 5 )
    _Keylist("Lower Number tends towards more deletes, higher towards more adds, 0 about even.")
    nAddWeight = _GetNum('Add Weight Value (5)?','99')
end

_KeyList("")

nReps = _GetNum('How many Repetitions?','99999')

for i = 1 to nReps

    nKey = inkey()

    if nKey = 27
        EXIT
    endif

    SELECT TestData

    nRec   = GetNumber()
    nBlock = GetNumber()
    lAdd   = iif(GetNumber() <=5+nAddWeight,TRUE,FALSE)

    GOTO nRec

    if lAdd

        // add @B.nBlock to comment

        cNotes1 = _LineEditGet(TestData->SerNo,'TESTNOTE','COMMENT')
        cNotes2 = TestData->MemoField

        cText = &('cB'+ltrim(str(nBlock)))


        cNotes1 += (LF+"COMMENT ADDED: "+dtoc(date())+' '+time()+LF+cText+LF)
        cNotes2 += (LF+"COMMENT ADDED: "+dtoc(date())+' '+time()+LF+cText+LF)

    else

        // delete comment
        cNotes1 = "COMMENT DELETED: "+dtoc(date())+' '+time()
        cNotes2 = "COMMENT DELETED: "+dtoc(date())+' '+time()

    endif

    @ 05,05 CLEAR TO 05,maxcol()

    @ 05,00 SAY 'Pass: '+ltrim(str(i))+'  Record: '+TestData->Name+'  '+iif(lAdd,'ADD   ','DELETE')

    @ 06,00 CLEAR TO maxrow(),maxcol()

    @ 06,00 say ""
    ?? cText

    _LineEditPut(TestData->SerNo,'TESTNOTE','COMMENT',cNotes1)


    REPLACE TestData->MemoField   WITH cNotes2
    REPLACE TestData->Access      WITH TestData->Access+1

    if lAdd
        REPLACE TestData->Add     WITH TestData->Add+1
    else
        REPLACE TestData->Delete  WITH TestData->Delete+1
    endif

next

CLOSE ALL

_Ack('Comment Blitz Done! - '+ltrim(str(i-1))+' Reps.')

RETURN(NIL)

**********************************************************************************************************************************
FUNCTION GetNumber()

LOCAL  nNum := 0

SELECT Numbers

nNum = numbers->Number

SKIP

if eof()
    GOTO TOP
end

SELECT TestData

RETURN(nNum)

